//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// StatisticsDlg.cpp : implementation file
//
#include "stdafx.h"
#include "emule.h"
#include "StatisticsDlg.h"
#include "math.h"

// CStatisticsDlg dialog

IMPLEMENT_DYNAMIC(CStatisticsDlg, CDialog)
CStatisticsDlg::CStatisticsDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CStatisticsDlg::IDD, pParent) , m_DownloadOMeter( 2 ),m_Statistics(4),m_UploadOMeter(2)
{

}

CStatisticsDlg::~CStatisticsDlg()
{
}

void CStatisticsDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExoSliderDlg)
	DDX_Text(pDX, IDC_SLIDER_VALUE, m_SliderValue);
	DDX_Control(pDX, IDC_STATISTICS, statlistctrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatisticsDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CStatisticsDlg)
	ON_WM_SHOWWINDOW()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CStatisticsDlg message handlers

BOOL CStatisticsDlg::OnInitDialog(){

	CResizableDialog::OnInitDialog();
	EnableWindow( FALSE );

	ShowSizeGrip(FALSE);
	AddAnchor(IDC_STATIC_LINE,TOP_LEFT ,TOP_RIGHT);
	AddAnchor(IDC_STATISTICS,TOP_LEFT ,BOTTOM_RIGHT);

	CRect rect;

	// Setup download-scope
	GetDlgItem(IDC_SCOPE_D)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_DownloadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_DownloadOMeter.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_DownloadOMeter.SetGridColor(RGB(192, 192, 255)) ;
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate(), 0) ;
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate(), 1) ;
	m_DownloadOMeter.SetPlotColor( RGB(0, 255, 0),1) ;
	m_DownloadOMeter.SetPlotColor( RGB(0, 150, 0),0) ;
	m_DownloadOMeter.SetYUnits("KB / s") ;
	m_DownloadOMeter.SetXUnits("Time");

	// Setup upload-scope
	GetDlgItem(IDC_SCOPE_U)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_UploadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_UploadOMeter.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_UploadOMeter.SetGridColor(RGB(192, 192, 255)) ;
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate(), 0) ;
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate(), 1) ;
	m_UploadOMeter.SetPlotColor( RGB(255, 0, 0),1) ;
	m_UploadOMeter.SetPlotColor( RGB(150, 0, 0),0) ;
	m_UploadOMeter.SetYUnits("KB / s") ;
	m_UploadOMeter.SetXUnits("Time");

	// Setup additional graph-scope
	GetDlgItem(IDC_STATSSCOPE)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_Statistics.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_Statistics.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_Statistics.SetGridColor(RGB(192, 192, 255)) ;
	stat_max=40;
	m_Statistics.SetRanges(0, stat_max) ;
	m_Statistics.autofitYscale=true;

	m_Statistics.SetPlotColor( RGB(155, 155, 0)  ,0) ;
	m_Statistics.SetPlotColor( RGB(192, 0,   192),1) ;
	m_Statistics.SetPlotColor( RGB(255, 192, 255),2) ;
	m_Statistics.SetPlotColor( RGB(255, 255, 128),3) ;
	m_Statistics.SetYUnits("") ;
	m_Statistics.SetXUnits("Time");

	SetupLegend( IDC_C0,   1 ,1);
	SetupLegend( IDC_C0_2, 0 ,1);
	
	SetupLegend( IDC_C1,   1 ,2 );
	SetupLegend( IDC_C1_2, 0 ,2 );

	//SetupLegend( IDC_S0, 0 ,3);
	SetupLegend( IDC_S1, 1 ,3);
	//SetupLegend( IDC_S2, 2 ,3);
	SetupLegend( IDC_S3, 3 ,3);

	UpdateData(FALSE);

	EnableWindow( TRUE );

	return true;
}

void CStatisticsDlg::SetupLegend( int ResIdx, int ElmtIdx, int legendNr){
	CRect Rect;

	GetDlgItem( ResIdx )->GetWindowRect( Rect );
	ScreenToClient( Rect );
	
	if (legendNr==1){
		m_Led1[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led1[ ElmtIdx ].SetBackgroundColor( m_DownloadOMeter.GetPlotColor( ElmtIdx ) );
		m_Led1[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	} else if (legendNr==2) {
		m_Led2[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led2[ ElmtIdx ].SetBackgroundColor( m_UploadOMeter.GetPlotColor( ElmtIdx ) );
		m_Led2[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	} else if (legendNr==3){
		m_Led3[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led3[ ElmtIdx ].SetBackgroundColor( m_Statistics.GetPlotColor( ElmtIdx ) );
		m_Led3[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	}
}


void CStatisticsDlg::SetCurrentRate(float uploadrate, float downloadrate) {
	double m_dPlotDataUp[ 2 ];
	double m_dPlotDataDown[ 2 ];

	// current rate
	m_dPlotDataDown[1]=downloadrate;
	m_dPlotDataUp[1]=uploadrate;

	// averages
	m_dPlotDataDown[0]=	GetAvgDownloadRate(AVG_SESSION);
	m_dPlotDataUp[0]=	GetAvgUploadRate(AVG_SESSION);


	// show
	m_DownloadOMeter.AppendPoints(m_dPlotDataDown);
	m_UploadOMeter.AppendPoints(m_dPlotDataUp);

}

void CStatisticsDlg::ShowStatistics() {
	char buffer[50];char buffer2[50];
	CString cbuffer;
	bool resize;
	int downStats[3];

	resize=false;

	// get Partialfiles summary
	theApp.downloadqueue->GetDownloadStats(downStats);

	m_dPlotDataMore[0]=0;//downStats[0];
	m_dPlotDataMore[1]=theApp.uploadqueue->GetUploadQueueLength();
	m_dPlotDataMore[2]=0;//theApp.uploadqueue->GetWaitingUserCount();
	m_dPlotDataMore[3]=downStats[1];

	for (int i=0;i<3;i++) if (m_dPlotDataMore[i]>stat_max) {resize=true;stat_max=m_dPlotDataMore[i];}
	if (resize) m_Statistics.SetRanges(0, ceil (stat_max+5)) ;
	 
	m_Statistics.AppendPoints(m_dPlotDataMore);

	CastItoXBytes( theApp.sessionReceivedBytes ,buffer);
	CastItoXBytes( theApp.sessionReceivedBytes+theApp.glob_prefs->GetTotalDownloaded() ,buffer2);
	cbuffer.Format("%s (%s)",buffer,buffer2);
	statlistctrl.Update(0,cbuffer);

	CastItoXBytes( theApp.sessionSentBytes  ,buffer);
	CastItoXBytes( theApp.sessionSentBytes+theApp.glob_prefs->GetTotalUploaded() ,buffer2);
	cbuffer.Format("%s (%s)",buffer,buffer2);
	statlistctrl.Update(1,cbuffer);

	if (theApp.prgstarttime>0) {
		cbuffer.Format("%.2f KB/s",GetAvgDownloadRate(AVG_SESSION));
		statlistctrl.Update(2,cbuffer);

		cbuffer.Format("%.2f KB/s",GetAvgUploadRate(AVG_SESSION));
		statlistctrl.Update(3,cbuffer);
	}

	statlistctrl.Update(4,downStats[0]);
	statlistctrl.Update(5,downStats[1]);
	statlistctrl.Update(6,theApp.uploadqueue->GetUploadQueueLength());
	statlistctrl.Update(7,theApp.uploadqueue->GetWaitingUserCount());

}

float CStatisticsDlg::GetAvgDownloadRate(int averageType) {
	if (theApp.prgstarttime==0) return 0;

	DWORD running=(GetTickCount()-theApp.prgstarttime)/1000;
	if (running<5) return 0;

	return (float)(theApp.sessionReceivedBytes/1024) / running;
}

float CStatisticsDlg::GetAvgUploadRate(int averageType) {
	if (theApp.prgstarttime==0) return 0;

	DWORD running=(GetTickCount()-theApp.prgstarttime)/1000;
	if (running<5) return 0;

	return (float)(theApp.sessionSentBytes/1024) / running;
}

void CStatisticsDlg::OnShowWindow(BOOL bShow,UINT nStatus){

}

void CStatisticsDlg::OnSize(UINT nType, int cx, int cy)
{
	CResizableDialog::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	//this will cause COScopeCtrl::OnSizeCall
	CRect rc;
	GetDlgItem(IDC_UPLOAD)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	m_DownloadOMeter.MoveWindow(&rc);

}  //OnSize

void CStatisticsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	int position = slider->GetPos();
	
	theApp.glob_prefs->SetTrafficOMeterInterval(position);
	ShowInterval(false);

	UpdateData(false); 
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CStatisticsDlg::ShowInterval(bool setSliderPosition) {
	EnableWindow( FALSE );

	if (setSliderPosition) ((CSliderCtrl*)GetDlgItem(IDC_SLIDER))->
		SetPos(theApp.glob_prefs->GetTrafficOMeterInterval());

	m_SliderValue.Format("Update delay: %i sec", theApp.glob_prefs->GetTrafficOMeterInterval());

	UpdateData(FALSE);
	EnableWindow( TRUE );
}

void CStatisticsDlg::SetARange(bool SetDownload,int maxValue){
	if (SetDownload) {
		m_DownloadOMeter.SetRange(0, maxValue, 0);
		m_DownloadOMeter.SetRange(0, maxValue, 1);
	}else{
		m_UploadOMeter.SetRange(0, maxValue, 0) ;
		m_UploadOMeter.SetRange(0, maxValue, 1);
	}
}
